set linesize 1000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set head off;
set verify off;
set termout off;
 
column u new_value us noprint;
column n new_value ns noprint;
 
select name n from v$database;
select user u from dual;
set sqlprompt &ns:&us>

set head on
set echo on
set termout on
set trimspool on
set serveroutput on size 1000000

spool &ns.createclobtable.log

-- need to keep the two cursors for edwprd performance
-- change to limit number of rows with variable counter

set define off

set timing on

drop table sqlclobs;

create table sqlclobs
(sqlnumber number,
sql_text clob);

DECLARE 
    CURSOR SQL_CURSOR IS 
        SELECT DISTINCT 
            SQL_ID,
            DBID
        FROM DBA_HIST_SQLSTAT; 
    SQL_REC SQL_CURSOR%ROWTYPE;
    CURSOR TEXT_CURSOR(SQL_ID_ARGUMENT VARCHAR2,DBID_ARGUMENT NUMBER) IS 
        SELECT  
            SQL_TEXT
        FROM DBA_HIST_SQLTEXT
        WHERE 
            ((SQL_TEXT like '%PLANTEST%')) and
            SQL_ID = SQL_ID_ARGUMENT and
            DBID = DBID_ARGUMENT;
    TEXT_REC TEXT_CURSOR%ROWTYPE;
    sqlnumber number;
    tempclob clob;
BEGIN
    sqlnumber := 1;
    OPEN SQL_CURSOR;
    LOOP
        FETCH SQL_CURSOR INTO SQL_REC;
        EXIT WHEN SQL_CURSOR%NOTFOUND;

        OPEN TEXT_CURSOR(SQL_REC.SQL_ID,SQL_REC.DBID);
        LOOP
            FETCH TEXT_CURSOR INTO TEXT_REC;
            EXIT WHEN TEXT_CURSOR%NOTFOUND;
            insert into sqlclobs values (sqlnumber,TEXT_REC.SQL_TEXT);
            commit;
            sqlnumber := sqlnumber + 1;
         END LOOP;
        CLOSE TEXT_CURSOR;
        EXIT WHEN sqlnumber > 3000;
     END LOOP;
    CLOSE SQL_CURSOR;
END;
/
show errors

select count(*),max(length(sql_text)) from sqlclobs;

set linesize 32767
set long 2000000000
set longchunksize 2000000000
set head off
-- set wrap off

select * from sqlclobs order by sqlnumber;

spool off
