set linesize 1000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set head off;
set verify off;
set termout off;
 
column u new_value us noprint;
column n new_value ns noprint;
 
select name n from v$database;
select user u from dual;
set sqlprompt &ns:&us>

set head on
set echo on
set termout on
set trimspool on
set serveroutput on size 1000000

spool &ns.makeplans.log

set define off

set timing on

truncate table plan_table;

DECLARE 
    CURSOR SQL_CURSOR IS 
        SELECT  
            sqlnumber,
            sql_text
        FROM sqlclobs
        ORDER by sqlnumber;
    SQL_REC SQL_CURSOR%ROWTYPE;
    EXPLAIN_SQL varchar2(32767);
    EXPLAIN_PREFIX varchar2(32767);
BEGIN
    OPEN SQL_CURSOR;
    LOOP
        FETCH SQL_CURSOR INTO SQL_REC;
        EXIT WHEN SQL_CURSOR%NOTFOUND;
        EXPLAIN_PREFIX := 'explain plan set statement_id = '''||SQL_REC.sqlnumber||''' into plan_table for ';
        IF LENGTH(SQL_REC.sql_text) < (32767-length(EXPLAIN_PREFIX)) then
            EXPLAIN_SQL := EXPLAIN_PREFIX||SQL_REC.sql_text;
--            dbms_output.put_line(substr(EXPLAIN_SQL,1,100));
            begin
                execute immediate EXPLAIN_SQL;
                DBMS_OUTPUT.put_line('Plan explained for SQL number '||SQL_REC.sqlnumber);
                EXCEPTION
	        WHEN others THEN
	            DBMS_OUTPUT.put_line('Error on SQL number '||SQL_REC.sqlnumber);
	            DBMS_OUTPUT.put_line(SQLERRM);
            end;
            commit;
        END IF;
     END LOOP;
    CLOSE SQL_CURSOR;
END;
/
show errors

select statement_id||' '||OPERATION||' '||OPTIONS||' '||OBJECT_NAME||' '||OBJECT_TYPE
from plan_table 
order by to_number(statement_id),id;

spool off
